#include <stdint.h>
#include "nrf_drv_gpiote.h"
#include "PrefiM_bsp.h"
#include "ble_sghs.h"
//#include "ble_sgis.h"
//#include "ble_sgss.h"
//#include "ble_sgds.h"
#include "globals.h"
#include "low_power_pwm.h"

// ****************************************  IO Interrupts  ****************************************

/*void DIP_handler(nrf_drv_gpiote_pin_t pin, nrf_gpiote_polarity_t action)
{
	uint8_t DIPstatus;
	
	DIPstatus = PMBSP_read_DIP();
	

	ble_sghs_on_dip_change(m_conn_handle,&m_sghs, DIPstatus);

	
}*/

//1void TAMPER_handler(nrf_drv_gpiote_pin_t pin, nrf_gpiote_polarity_t action)
//1{
//	bsp_board_led_invert(0);
	
//	advertising_start(true);

//1	ble_sghs_on_tamper_change(m_conn_handle,&m_sghs, nrf_drv_gpiote_in_is_set(pin));
	
/*
	if(nrf_drv_gpiote_in_is_set(pin))
		ble_sghs_on_tamper_change(m_conn_handle,&m_sghs, nrf_drv_gpiote_in_is_set(pin));
	else
		ble_sghs_on_tamper_change(m_conn_handle,&m_sghs, 0);
*/
//1}

/*void MAGNET_handler(nrf_drv_gpiote_pin_t pin, nrf_gpiote_polarity_t action)
{
//	ble_sghs_on_mkey_change(m_conn_handle,&m_sghs, nrf_drv_gpiote_in_is_set(pin));
	

	if(!nrf_drv_gpiote_in_is_set(pin))
		ble_sghs_on_mkey_change(m_conn_handle,&m_sghs, 1);
	else
		ble_sghs_on_mkey_change(m_conn_handle,&m_sghs, 0);

}*/

// ****************************************  Application Timer Interrupts  ****************************************

/**
 * @brief Function to be called in timer interrupt.
 *
 * @param[in] p_context     General purpose pointer (unused).
 */
void PMINT_pwm_handler(void * p_context)
{
    uint8_t new_duty_cycle;
    static uint16_t led_0, led_1;
    uint32_t err_code;
    UNUSED_PARAMETER(p_context);

	return;
	
    low_power_pwm_t * pwm_instance = (low_power_pwm_t*)p_context;

    if (pwm_instance->bit_mask == BSP_LED_R_MASK)
    {
        led_0++;

        if (led_0 > TICKS_BEFORE_CHANGE_0)
        {
            new_duty_cycle = pwm_instance->period - pwm_instance->duty_cycle;
            err_code = low_power_pwm_duty_set(pwm_instance, new_duty_cycle);
            led_0 = 0;
            APP_ERROR_CHECK(err_code);
        }
    }
    else if (pwm_instance->bit_mask == BSP_LED_G_MASK)
    {
        led_1++;

        if (led_1 > TICKS_BEFORE_CHANGE_1)
        {
            new_duty_cycle = pwm_instance->period - pwm_instance->duty_cycle;
            err_code = low_power_pwm_duty_set(pwm_instance, new_duty_cycle);
            led_1 = 0;
            APP_ERROR_CHECK(err_code);
        }
    }
    else
    {
        /*empty else*/
    }
}
