#include "imageProcessing.h"
#include <math.h>
#include "app_error.h"
#include "nrf_drv_uart.h"
#include "nrf_gpio.h"
#include "common_definitions.h"
#include "globals.h"
#include "app_timer.h"
#include "nrf_delay.h"




locationStruct areasOfInterest[32]; 
bool runFlag = true;
short areaCount = 0;

//variabler fr att hantera historik och snittemperaturer
short tempAverage[32][32];
short tempHist_1[32][32];
short tempHist_2[32][32];
short tempHist_3[32][32];
short tempHist_4[32][32];
//short tempHist_5[32][32];

int tempHistPerColumn_0s[PIX_PER_ROW];
int tempHistPerColumn_1s[PIX_PER_ROW];

int numberOfHumanPixels_hist[10];
int averageOfHumanPixels;

locationStruct areasOfInterest_Hist[32];

short edgeImage[NUMBER_OF_ROWS][PIX_PER_ROW];
//short averageFilteredImage[NUMBER_OF_ROWS][PIX_PER_ROW];
//extern short rawPixData[NUMBER_OF_ROWS][PIX_PER_ROW];								//denna variabel anvnds bde i imageProcessing.c och heimann32x32. r definierad i heimann32x32
/*
void sendInterestingAOI(char numberOfAOI)
{
	uint8_t err_code;
	uint8_t tempTxBuffer[2];
	uint8_t messageHeader[10]={'N','r',' ','o','f',' ','A','O','I',':'};
	uint8_t messageXpos[6] = {'X','-','p','o','s',':'};
	uint8_t messageYpos[6] = {'Y','-','p','o','s',':'};
 	uint8_t messageTemperature[5] = {'T','e','m','p',':'};
	uint8_t messageSize[5] = {'S','i','z','e',':'};
	uint8_t messageEnd[3]={'E','N','D'};
	
	//for(int i=0;i<NUMBER_OF_ROWS;i++)
	err_code = nrf_drv_uart_tx(messageHeader,10);
	APP_ERROR_CHECK(err_code);
	tempTxBuffer[0] = numberOfAOI;
	//tempTxBuffer[0]=0;
	//tempTxBuffer[1] = numberOfAOI;
	err_code = nrf_drv_uart_tx(tempTxBuffer,1);
	

	for(int i=0;i<numberOfAOI;i++)
	{
				//tempTxBuffer[0]=0;
				//err_code = nrf_drv_uart_tx(messageXpos,6);	
				tempTxBuffer[0] = areasOfInterest[i].xPos;
				err_code = nrf_drv_uart_tx(tempTxBuffer,1);
		
				//tempTxBuffer[0]=0;
				//err_code = nrf_drv_uart_tx(messageYpos,6);
				tempTxBuffer[0] = areasOfInterest[i].yPos;
				err_code = nrf_drv_uart_tx(tempTxBuffer,1);
		
				//tempTxBuffer[0]=0;
				//err_code = nrf_drv_uart_tx(messageTemperature,5);
		
			
				tempTxBuffer[0] = areasOfInterest[i].hotestTemperature;
				err_code = nrf_drv_uart_tx(tempTxBuffer,1);
		
				//err_code = nrf_drv_uart_tx(messageSize,5);
				tempTxBuffer[0] = areasOfInterest[i].size;
				err_code = nrf_drv_uart_tx(tempTxBuffer,1);
		
	}
	err_code = nrf_drv_uart_tx(messageEnd,3);
	APP_ERROR_CHECK(err_code);
}
void sendEdgeImage(void)
{
	uint8_t err_code;
	uint8_t tempTxBuffer[2];
	uint8_t messageHeader[5]={'r','o','w','0','0'};
	uint8_t messageEnd[3]={'E','N','D'};
	
	
	
	//for(int i=0;i<NUMBER_OF_ROWS;i++)
	for(int i=0;i<32;i++)
	{
		switch (i)
		{
			case 0:
				messageHeader[4]='0';
				break;
			case 1:
				messageHeader[4]='1';
				break;		
			case 2:
				messageHeader[4]='2';
				break;		
			case 3:
				messageHeader[4]='3';
				break;
			case 4:
				messageHeader[4]='4';
				break;
			case 5:
				messageHeader[4]='5';
				break;		
			case 6:
				messageHeader[4]='6';
				break;		
			case 7:
				messageHeader[4]='7';
				break;
			case 8:
				messageHeader[4]='8';
				break;
			case 9:
				messageHeader[4]='9';
				break;		
			case 10:
				messageHeader[3]='1';
				messageHeader[4]='0';
				break;	
			case 11:
				messageHeader[3]='1';	
				messageHeader[4]='1';
				break;			
			case 12:
				messageHeader[3]='1';	
				messageHeader[4]='2';
				break;
			case 13:
				messageHeader[3]='1';	
				messageHeader[4]='3';
				break;
			case 14:
				messageHeader[3]='1';	
				messageHeader[4]='4';
				break;
			case 15:
				messageHeader[3]='1';	
				messageHeader[4]='5';
				break;
			case 16:
				messageHeader[3]='1';	
				messageHeader[4]='6';
				break;
			case 17:
				messageHeader[3]='1';	
				messageHeader[4]='7';
				break;
			case 18:
				messageHeader[3]='1';	
				messageHeader[4]='8';
				break;
			case 19:
				messageHeader[3]='1';	
				messageHeader[4]='9';
				break;
			case 20:
				messageHeader[3]='2';	
				messageHeader[4]='0';
				break;
			case 21:
				messageHeader[3]='2';	
				messageHeader[4]='1';
				break;			
			case 22:
				messageHeader[3]='2';	
				messageHeader[4]='2';
				break;				
			case 23:
				messageHeader[3]='2';	
				messageHeader[4]='3';
				break;	
			case 24:
				messageHeader[3]='2';	
				messageHeader[4]='4';
				break;	
			case 25:
				messageHeader[3]='2';	
				messageHeader[4]='5';
				break;	
			case 26:
				messageHeader[3]='2';	
				messageHeader[4]='6';
				break;	
			case 27:
				messageHeader[3]='2';	
				messageHeader[4]='7';
				break;	
			case 28:
				messageHeader[3]='2';	
				messageHeader[4]='8';
				break;	
			case 29:
				messageHeader[3]='2';	
				messageHeader[4]='9';
				break;	
			case 30:
				messageHeader[3]='3';	
				messageHeader[4]='0';
				break;	
			case 31:
				messageHeader[3]='3';	
				messageHeader[4]='1';
				break;	
			
			
		}
		
		err_code = nrf_drv_uart_tx(messageHeader,5);
		APP_ERROR_CHECK(err_code);
		for(int j=0;j<PIX_PER_ROW;j++)
		{
				tempTxBuffer[0]=0;
				tempTxBuffer[1] = edgeImage[i][j];
				err_code = nrf_drv_uart_tx(tempTxBuffer,2);
		}
		err_code = nrf_drv_uart_tx(messageEnd,3);
		APP_ERROR_CHECK(err_code);
	}
}*/

char lookForAreasOfInterest()
{
		
	//short rowCount = 0;
	//short pixCount = 0;
	//short firstRow = 0;
	
	
	areaCount = 0;
	//rowCount = 0;
	for(int i = 0;i<NUMBER_OF_ROWS;i++)
	{
		
		for(int j=0;j<PIX_PER_ROW;j++)
		{
				if(edgeImage[i][j] == 1)
				{
				
					areasOfInterest[areaCount] = checkArea(i,j);
					
					
					eraseArea(areasOfInterest[areaCount].xMin,areasOfInterest[areaCount].xMax, areasOfInterest[areaCount].yMin, areasOfInterest[areaCount].yMax);
					areaCount++;
				}
				else;
					//j = j+lengthOfArea;
					
		}
	}
	
	//Nolla resterarande AOI:s i vektorn
	
	for(int j = areaCount;j<32;j++)
	{
		areasOfInterest[j].inUse = false;
	}
	
	return areaCount;
}
void averageFilteringOverTime()
{
		
		/*for(int i = 0;i<NUMBER_OF_ROWS;i++)
		{
			for(int j=0;j<PIX_PER_ROW;j++)
			{
			
				tempAverage[i][j]=(rawPixData[i][j]+tempHist_1[i][j]+tempHist_2[i][j]+tempHist_3[i][j]+tempHist_4[i][j])/5;
				tempHist_4[i][j]=tempHist_3[i][j];
				tempHist_3[i][j]=tempHist_2[i][j];
				tempHist_2[i][j]=tempHist_1[i][j];
				tempHist_1[i][j]=tempAverage[i][j];
			}
		}*/
	
	
}
void eraseArea(short xMin, short xMax, short yMin, short yMax)
{
	int i = 0;
	int j = 0;
	 
	i = yMin;
	j = xMin;
	
	for(i;i<=yMax;i++)
	{
		j=xMin;
 		for(j;j<=xMax;j++)
		{
				edgeImage[i][j] = 0;
				if(SensorImage[i][j] > areasOfInterest[areaCount].hotestTemperature)
				{
					areasOfInterest[areaCount].hotestTemperature = SensorImage[i][j];
					areasOfInterest[areaCount].xPos = j;
					areasOfInterest[areaCount].yPos = i;
				}			
		}
	}
	
	
	 
}
char someonePresent(int lookToRow)
{
	
	int numberOfHumanPixels = 0;
	int diffOfHumanPixels = 0;
	
	
	for(int column = 0;column< PIX_PER_ROW;column++)
	{
		tempHistPerColumn_0s[column]=0;
		for(int row = 0;row<=lookToRow;row++)
		{
				if((SensorImage[row][column] > BODY_TEMP_LOWER_LIMIT)&&(SensorImage[row][column] < BODY_TEMP_UPPER_LIMIT))
				{
					numberOfHumanPixels++;
					tempHistPerColumn_0s[column]++;
				}			
		}
	}
	averageOfHumanPixels=0;
	for(int j=9;j>0;j--)
	{
		numberOfHumanPixels_hist[j] = numberOfHumanPixels_hist[j-1];
		if(j<10)
		 	averageOfHumanPixels = averageOfHumanPixels + numberOfHumanPixels_hist[j];
	
	}
	averageOfHumanPixels = (int)averageOfHumanPixels / 10;
	
	numberOfHumanPixels_hist[0] = numberOfHumanPixels;
	diffOfHumanPixels = abs(numberOfHumanPixels-averageOfHumanPixels);
 	if(diffOfHumanPixels>HUMAN_PIXELS_DELTA_TRESHHOLD)
	{
			//set_leds(0xff,0x00,0x00,0xff);
			//nrf_delay_ms(500);
			//set_leds(0x00,0x00,0x00,0xff);
			//nrf_gpio_pin_set(LED_1);
			//nrf_delay_ms(200);
			//nrf_gpio_pin_clear(LED_1);
			//nrf_delay_ms(1000);
		return true;
	}
	else
		return false;
	
}
char someoneMoving(int lookToRow)
{
	//char resultFlag = false
	int tempHistDiff = 0;
	for(int column = 0;column< PIX_PER_ROW;column++)
	{
			tempHistDiff += abs(tempHistPerColumn_0s[column]-tempHistPerColumn_1s[column]);
			tempHistPerColumn_1s[column] = tempHistPerColumn_0s[column];
			
		
	}	
	if(tempHistDiff>40)
	{
			//nrf_gpio_pin_set(LED_0);
			//set_leds(0x00,0xff,0x00,0xff);
			//nrf_delay_ms(500);
			//set_leds(0x00,0x00,0x00,0xff);
			//nrf_gpio_pin_clear(LED_0);
			//nrf_delay_ms(1000);
		return true;
	}
	else
	  return false;
	
}
char analyzeTemperature()
{
	char resultOfAOIAnalysis;
	char numberOfInterestingAreas;
	locationStruct result;
	
	//char presenceFlag;
	//char movementFlag;
	
	numberOfInterestingAreas  = 0;
	//averageFilteringOverTime();
	//averageFilter();
	
	//presenceFlag = someonePresent(16);
	//movementFlag = someoneMoving(16);
	
	
	
	result = lookForTheHotestArea(0,0);
	
	if(result.hotestTemperature>TL_STOVE_ON)
	{
		edgeFilter();
		numberOfInterestingAreas = lookForAreasOfInterest();
		if(numberOfInterestingAreas > 0)
		{
			 resultOfAOIAnalysis = analyzeAOI(numberOfInterestingAreas);
		
				saveAreasOfInterest();
				
		}

		return resultOfAOIAnalysis;
	}
	else
	{
		eraseAreasOfInterest();
		return 0;
	}
	
	
}
void eraseAreasOfInterest()
{
	int i= 0;
	while((areasOfInterest[i].inUse != false)||(i<32))
	{
			areasOfInterest[i].inUse = false;
			i++;
	}
	
}
void saveAreasOfInterest()
{
	int i= 0;
	while((areasOfInterest[i].inUse == true)&&(i<32))
	{
			areasOfInterest_Hist[i].inUse = areasOfInterest[i].inUse;
			areasOfInterest_Hist[i].xMin = areasOfInterest[i].xMin;
			areasOfInterest_Hist[i].xMax = areasOfInterest[i].xMax;
			areasOfInterest_Hist[i].yMin = areasOfInterest[i].yMin;
			areasOfInterest_Hist[i].yMax = areasOfInterest[i].yMax;
			areasOfInterest_Hist[i].hotestTemperature = areasOfInterest[i].hotestTemperature;
			areasOfInterest_Hist[i].size = areasOfInterest[i].size;
			areasOfInterest_Hist[i].xPos = areasOfInterest[i].xPos;
			areasOfInterest_Hist[i].yPos = areasOfInterest[i].yPos;
			i++;
	}
	//Nolla resterarande AOI:s i vektorn
	for(i = 0;i<32;i++)
	{
		areasOfInterest_Hist[i].inUse = false;
	}
}
char checkForRapidTemperatureIncrease()
{
	int i= 0;
	int m = 0;
	int n = 0;
	int numberOfRapidTemperatureIncreasePixels = 0;
	int temperatureDifference = 0;
	char result = false;
	
	while((areasOfInterest_Hist[i].inUse != false)&&(i<32))
	{
			numberOfRapidTemperatureIncreasePixels = 0;
			for(n=areasOfInterest_Hist[i].yMin;n<areasOfInterest_Hist[i].yMax;n++)
			{
					
				for(m=areasOfInterest_Hist[i].xMin;m<areasOfInterest_Hist[i].xMax;m++)
				{
					if(tempHist_1[n][m]>tempHist_2[n][m])
					{
						temperatureDifference = tempHist_1[n][m]-tempHist_2[n][m];
						if(temperatureDifference > HIGH_POS_DEVERIVATE_LEVEL)
							numberOfRapidTemperatureIncreasePixels++;
					}
				}
				
				//Om omrdet med positiv derivate r strre n denna niv s har vi en positiv derivata
				if(numberOfRapidTemperatureIncreasePixels>NUMBER_OF_HIGH_POS_DERIVATE_PIXELS)
					result = true;
			}
				
			i++;
	}
	
	return result;
}
char analyzeAOI(char numberOfAreasToAnalyze)
{
	char result = 0;
	int i = 0;
	for(i;i<numberOfAreasToAnalyze;i++)
	{
		if(areasOfInterest[i].hotestTemperature > TL_CUT_POWER)
		{
			result = TF_CUT_POWER ;
		}	
		else if(areasOfInterest[i].hotestTemperature > TL_LARM_SOUND)
		{
			if(result < TF_SOUND_LARM)
				result = TF_SOUND_LARM;
		}	
		else if(areasOfInterest[i].hotestTemperature > TL_LARM_VISUAL)
		{
			if(result < TF_VISUAL_LARM)
				result = TF_VISUAL_LARM;
		}	
		else if(areasOfInterest[i].hotestTemperature > TL_OVER_BOILING)
		{
			if(result < TF_OVER_BOILING)
				result = TF_OVER_BOILING;
		}	
		else if(areasOfInterest[i].hotestTemperature > TL_STOVE_ON)
		{
			if(result < TF_STOVE_ON)
				result = TF_STOVE_ON;
		}	
		else if(areasOfInterest[i].hotestTemperature <= TL_STOVE_ON)
		{
				result = TF_STOVE_OFF;
		}
	}
	
	return result;
}


locationStruct lookForTheHotestArea(int i, int j)
{
	short maxTemperature = 0;
	locationStruct positionOfHotestArea;


	for(int i = 0;i<NUMBER_OF_ROWS;i++)
	{
		for(int j=0;j<PIX_PER_ROW;j++)
		{
			if(SensorImage[i][j]>maxTemperature)
			{
					maxTemperature = SensorImage[i][j];
					positionOfHotestArea.xMin=j;
					positionOfHotestArea.yMin=i;
					
			}
		
		}
	}
	positionOfHotestArea.hotestTemperature=maxTemperature;
	return positionOfHotestArea;
}
locationStruct checkArea(int i, int j)
{

	short xMax = j;
	short yMax = i;
	short yMin = i;
	short xMin = j;
	short maskState;
	bool runFlag = true;
	int widthOfArea = 0;
	int heightOfArea = 0;
	locationStruct result;
	
	
	
	maskState = CHECK_RIGHT;
	while(runFlag)
	{	
			switch(maskState)
			{
				case CHECK_RIGHT:
					if(checkUpRight(i,j))
					{
						maskState = CHECK_UP_RIGHT;
						j++;
						i--;
			
					}
			
					else if(checkRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						if(j>xMax)
							xMax=j;
					}
					else if (checkDownRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						i++;
						if(j>xMax)
							xMax=j;					
						if(i>yMax)
							yMax=i;
					}
					else if(checkDown(i,j))
					{
						maskState = CHECK_DOWN;
						i++;
						if(i>yMax)
							yMax=i;
					}
					else if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
		
					else
						runFlag = false;
						
					break;
			case CHECK_DOWN_RIGHT:
					if(checkRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						if(j>xMax)
							xMax=j;
						if(i>yMax)
							yMax=i;
					}
					else if (checkDownRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						i++;
						if(j>xMax)
							xMax=j;					
						if(i>yMax)
							yMax=i;
					}
					else if(checkDown(i,j))
					{
						maskState = CHECK_DOWN;
						i++;
						if(i>yMax)
							yMax=i;
					}
					else if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else
						runFlag = false;
						
					break;
						

				case CHECK_DOWN:
				
					if(checkDownRight(i,j))
					{
						maskState = CHECK_DOWN_RIGHT;
						i++;
						j++;
						if(j>xMax)
							xMax = j;
						if(i>yMax)
							yMax=i;
					}
					else if(checkDown(i,j))
					{
						maskState = CHECK_DOWN;
						i++;

						if(i>yMax)
							yMax = i;
					}
					else if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							i++;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
				
					else
						runFlag = false;
						
					break;
					
				case CHECK_DOWN_LEFT:
				
					if(checkDownRight(i,j))
					{
						maskState = CHECK_DOWN_RIGHT;
						i++;
						j++;
						if(j>xMax)
							xMax = j;
						if(i>yMax)
							yMax=i;
					}
					else if(checkDown(i,j))
					{
						maskState = CHECK_DOWN;
						i++;

						if(i>yMax)
							yMax=i;
					}
					else if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
				
					else
						runFlag = false;
						
					break;
					
			case CHECK_LEFT:
				
				
					if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
					else if(checkUp(i,j))
					{
						maskState = CHECK_UP;
						
						i--;
			
					}
					else
						runFlag = false;
						
					break;
				
			case CHECK_UP_LEFT:
				
				
					if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
					else if(checkUp(i,j))
					{
						maskState = CHECK_UP;
						
						i--;
			
					}
					else if(checkUpRight(i,j))
					{
						maskState = CHECK_UP;
						j++;
						i--;
			
					}
					else
						runFlag = false;
						
					break;
					
					
			case CHECK_UP:
				
					if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
					else if(checkUp(i,j))
					{
						maskState = CHECK_UP;
						
						i--;
			
					}
					else if(checkUpRight(i,j))
					{
						maskState = CHECK_UP_RIGHT;
						j++;
						i--;
			
					}
					else if(checkRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						
			
					}
					else
						runFlag = false;
						
					break;
					
			case CHECK_UP_RIGHT:
				
					if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
					else if(checkUp(i,j))
					{
						maskState = CHECK_UP;
						
						i--;
			
					}
					else if(checkUpRight(i,j))
					{
						maskState = CHECK_UP_RIGHT;
						j++;
						i--;
			
					}
					else if(checkRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						if(j > xMax)
							xMax = j;
						
			
					}
					else
						runFlag = false;
						
					break;				
					
					
				
	}
	

	
	}
	result.xMax=xMax;
	result.xMin=xMin;
	result.yMax=yMax;
	result.yMin=yMin;
	result.inUse = true;
	widthOfArea = xMax - xMin;
	if(widthOfArea==0)
		widthOfArea=1;
	heightOfArea = yMax - yMin;
	if(heightOfArea==0)
		heightOfArea=1;
	result.hotestTemperature = 0;
	result.size = widthOfArea*heightOfArea;
	
	result.size = widthOfArea * heightOfArea;
	
	return result;
	
}

char checkRight(int i, int j)
{
	if(j< (PIX_PER_ROW-1))
	{
		if(edgeImage[i][j+1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i][j+1]==1)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkDownRight(int i, int j)
{
	if((j<(PIX_PER_ROW-1))&&(i<(NUMBER_OF_ROWS-1)))
	{
		if(edgeImage[i+1][j+1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i+1][j+1]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkDown(int i, int j)
{
	if(i < (NUMBER_OF_ROWS-1))
	{
		if(edgeImage[i+1][j]==1)
		{
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i+1][j]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkDownLeft(int i, int j)
{
	if(j>0&&(i<(NUMBER_OF_ROWS-1)))
	{
		if(edgeImage[i+1][j-1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i+1][j-1]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;	
}
char checkLeft(int i, int j)
{	
	if(j>0)
	{
		if(edgeImage[i][j-1]==1)
		{
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkUpLeft(int i, int j)
{
	if((j>0)&&(i>0))
	{
		if(edgeImage[i-1][j-1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i-1][j-1]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkUp(int i, int j)
{
	if(i>0)
	{
		if(edgeImage[i-1][j]==1)
		{
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i-1][j]==BT_VALUE)
		{
				runFlag = false;
				return true;
		}
		else
			return false;
	}
	else
			return false;
}
char checkUpRight(int i, int j)
{
	if((j<(PIX_PER_ROW-1))&&(i>0))
	{
		if(edgeImage[i-1][j+1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i-1][j+1]==BT_VALUE)
		{
				runFlag = false;
				return true;
		}
		else
			return false;
	}
	else
		return false;
}
void edgeFilter()
{
	/*short rowOffset;
	short colOffset;
	short sobel[3][3];
	sobel[0][0]=1;
	sobel[0][1]=2;
	sobel[0][2]=1;
	sobel[1][0]=0;
	sobel[1][1]=0;
	sobel[1][2]=0;
	sobel[2][0]=-1;
	sobel[2][1]=-2;
	sobel[2][2]=-1;
	*/
	/*
	for(int i = 2;i<NUMBER_OF_ROWS-1;i++)
	{
		for(int j=2;j<PIX_PER_ROW-1;j++)
		{
			edgeImage[i][j]=0;
			for (rowOffset=-1; rowOffset<=1; rowOffset++) 
			{
							
				for (colOffset=-1; colOffset<=1; colOffset++) 
				{
					edgeImage[i][j] += sobel[1 + rowOffset][1 + colOffset]*averageFilteredImage[i-rowOffset][j-colOffset];
				}
			}
			if(edgeImage[i][j] > 50)
				//edgeImage[i][j] = THRESHOLD;
			else
				edgeImage[i][j] = 0;
		}
	}
	*/
	for(int i = 0;i<NUMBER_OF_ROWS;i++)
	{
		for(int j=0;j<PIX_PER_ROW;j++)
		{
			if(SensorImage[i][j] > TL_STOVE_ON)
				edgeImage[i][j]=1;
			else
				edgeImage[i][j]=0;
		}
	}
	//sendEdgeImage();
	
}
void averageFilter()
{
	for(int i = 0;i<NUMBER_OF_ROWS;i++)
	{
		for(int j=0;j<PIX_PER_ROW;j++)
		{
	/*		if(j>3 && j <(PIX_PER_ROW-2))
				averageFilteredImage[i][j]=(tempAverage[i][j-2]+tempAverage[i][j-1]+tempAverage[i][j]+tempAverage[i][j+1]+tempAverage[i][j+2])/5;
			else if(j<=3)
				averageFilteredImage[i][j]=(tempAverage[i][j]+tempAverage[i][j+1]+tempAverage[i][j+2]+tempAverage[i][j+3]+tempAverage[i][j+4])/5;
			else if(j>=(PIX_PER_ROW-2))
				averageFilteredImage[i][j]=tempAverage[i][j];
		*/	
				
		}
	}
	
}
