#include "PrefiM_bsp.h"
#include "nrf_delay.h"
#include "nrf_gpio.h"
#include "globals.h"
#include "indications.h"
#include "m_ApplicationInterface.h"
//int whenToMakeSoundIndication = 0;
void indicationsStartup()
{
	PMAIF_LED_Set(ALL_OFF,SOLID);
	//PMAIF_SUMMER_Set(OFF);
}
void indicationsStoveOff()
{
	if(DIP_LED_Indicator == TRUE)
	{
		#ifdef BATTERY_DRIVEN
			PMAIF_LED_Set(ALL_OFF,SOLID);
		#else
			PMAIF_LED_Set(GREEN,SOLID);
		#endif
	}
	else
		PMAIF_LED_Set(ALL_OFF,SOLID);
}
void indicationsStoveOn()
{
	#ifdef BATTERY_DRIVEN
	if(whenToFlash > flashIntervalStoveOn)
	{
		PMAIF_LED_Set(GREEN,SOLID);
		nrf_delay_ms(1);
		PMAIF_LED_Set(ALL_OFF,SOLID);
		//nrf_delay_ms(5000);
		
		whenToFlash = 0;
		
	}
	else
		whenToFlash++;
		
	#else
	if(DIP_LED_Indicator == TRUE)
		PMAIF_LED_Set(GREEN,SLOW_BLINK);
	else
		PMAIF_LED_Set(ALL_OFF,SOLID);
	#endif
	if(DIP_use_Indicator == TRUE)
	{
		#ifdef BATTERY_DRIVEN
		#else
		if(whenToMakeSoundIndication > 4)
		{
			beep();						//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
		#endif
	}
}
void indicationsALARMDELAY()
{
	#ifdef BATTERY_DRIVEN
	if(whenToFlash > flashIntervalStoveOn)
	{
		PMAIF_LED_Set(GREEN,SOLID);
		nrf_delay_ms(10);
		PMAIF_LED_Set(ALL_OFF,SOLID);
		
		whenToFlash = 0;
		
	}
	else
		whenToFlash++;
		
	#else
	if(DIP_LED_Indicator == TRUE)
		PMAIF_LED_Set(GREEN,SLOW_BLINK);
	else
		PMAIF_LED_Set(ALL_OFF,SOLID);
	#endif
	if(DIP_use_Indicator == TRUE)
	{
		#ifdef BATTERY_DRIVEN
		#else
		if(whenToMakeSoundIndication > 4)
		{
			beep();					//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
		#endif
	}
}
void indicationsTemperatureWarningLevel_1()
{
	if(DIP_LED_Indicator == TRUE)
	{
			PMAIF_LED_Set(YELLOW,SOLID);
			nrf_delay_ms(10);
			PMAIF_LED_Set(ALL_OFF,SOLID);
	}
	else
		PMAIF_LED_Set(ALL_OFF,SOLID);
	#ifndef BATTERI_DRIVEN
	if(DIP_use_Indicator == TRUE)
	{
		if(whenToMakeSoundIndication > 4)
		{
			beep();						//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
	}
	#endif
	
}
void indicationsTemperatureWarningLevel_2()
{
	if(DIP_LED_Indicator == TRUE)
	{
			PMAIF_LED_Set(RED,SOLID);
			nrf_delay_ms(10);
			PMAIF_LED_Set(ALL_OFF,SOLID);
	}
	else
		PMAIF_LED_Set(ALL_OFF,SOLID);
	
	if(whenToMakeSoundIndication > 4)
	{
		beep();						//Pip
		whenToMakeSoundIndication = 0;			
	}
	else
		whenToMakeSoundIndication++;
	
	if(DIP_use_Indicator == TRUE)
	{
		//if(whenToMakeSoundIndication > 4)
		//{
			beep();						//Pip
		//	whenToMakeSoundIndication = 0;			
		//}
		//else
		//	whenToMakeSoundIndication++;
	}
}
void indicationsFire()
{
	
}
void indicationsShutdownTime()
{
	#ifdef BATTERY_DRIVEN
	if(whenToFlash > flashIntervalStoveOn)
	{
		PMAIF_LED_Set(YELLOW,SOLID);
		nrf_delay_ms(10);
		PMAIF_LED_Set(ALL_OFF,SOLID);
		
		whenToFlash = 0;
		
	}
	else
		whenToFlash++;
	#else
	PMAIF_LED_Set(YELLOW,SOLID);
	#endif
	
	if(DIP_Sound_warning == TRUE)
	{
		if(whenToMakeSoundIndication > soundIntervalShutdownTime)
		{
			beep();					//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
	}
}
void indicationsShutdownTemperature()
{
	#ifdef BATTERY_DRIVEN
	if(whenToFlash > flashIntervalStoveOn)
	{
		PMAIF_LED_Set(RED,SOLID);
		nrf_delay_ms(10);
		PMAIF_LED_Set(ALL_OFF,SOLID);
		
		whenToFlash = 0;
		
	}
	else
		whenToFlash++;
	#else
	PMAIF_LED_Set(RED,SOLID);
	#endif
	if(DIP_Sound_warning == TRUE)
	{
		if(whenToMakeSoundIndication > soundIntervalShutdownTempterature)
		{
			beep();					//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
	}
}
void indicationsShutdownMagnet()
{
	#ifdef BATTERY_DRIVEN
		if(whenToFlash > flashIntervalStoveOn)
	{
		PMAIF_LED_Set(RED,SOLID);
		nrf_delay_ms(10);
		PMAIF_LED_Set(ALL_OFF,SOLID);
		
		whenToFlash = 0;
		
	}
	else
		whenToFlash++;
	#else
	PMAIF_LED_Set(RED,SOLID);
	#endif
	if(DIP_Sound_warning == TRUE)
	{
		if(whenToMakeSoundIndication > soundIntervalShutdownMagnet)
		{
			beep();					//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
	}
}
void indicationsShutdownAmbientTemp()
{
	#ifdef BATTERY_DRIVEN
	if(whenToFlash > flashIntervalStoveOn)
	{
		PMAIF_LED_Set(RED,SOLID);
		nrf_delay_ms(10);
		PMAIF_LED_Set(ALL_OFF,SOLID);
		
		whenToFlash = 0;
		
	}
	else
		whenToFlash++;
	#else
		PMAIF_LED_Set(RED,SOLID);
	#endif
	if(DIP_Sound_warning == TRUE)
	{
		if(whenToMakeSoundIndication > soundIntervalShutdownAmbientTemp)
		{
			beep();						//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
	}
}
void indicationsPREREST()
{
	#ifdef BATTERY_DRIVEN
	if(whenToFlash > flashIntervalStoveOn)
	{
		PMAIF_LED_Set(RED,SOLID);
		nrf_delay_ms(10);
		PMAIF_LED_Set(ALL_OFF,SOLID);
		
		whenToFlash = 0;
		
	}
	else
		whenToFlash++;
	#else
		PMAIF_LED_Set(RED,SOLID);
	#endif
	if(DIP_Sound_warning == TRUE)
	{
		if(whenToMakeSoundIndication > soundIntervalPRE_REST)
		{
			beep();						//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
	}
}
void indicationsRESTDELAY()
{
	#ifdef BATTERY_DRIVEN
	#else
		PMAIF_LED_Set(GREEN,SLOW_BLINK);
	#endif
	if(DIP_Sound_warning == TRUE)
	{
		if(whenToMakeSoundIndication > soundIntervalREST_DELAY)
		{
			beep();					//Pip
			whenToMakeSoundIndication = 0;			
		}
		else
			whenToMakeSoundIndication++;
	}
}
	
