#include <stdint.h>
#include <stdlib.h>
#include "globals.h"
#include "m_SensorProcessing.h"
//#include <math.h>
#include "nrf_delay.h"
#include "m_DebugUart.h"
#include "PrefiM_bsp.h"
#include "m_ApplicationInterface.h"

//extern locationStruct areasOfInterest[32]; 
bool runFlag = true;
short areaCount = 0;

//variabler fr att hantera historik och snittemperaturer
//short tempAverage[32][32];
//short tempHist_1[32][32];
//short tempHist_2[32][32];
//short tempHist_3[32][32];
//short tempHist_4[32][32];
short tempDiffImage_1s[32][32];
#define ROW_FOR_PRESENCE_DETECTION 20
int tempHistPerColumn_0s[PIX_PER_ROW];
int tempHistPerColumn_1s[PIX_PER_ROW];
//int numberOfSharpEdgesPerColumn_0s[PIX_PER_ROW];
int numberOfEdgesPerColumn[PIX_PER_ROW];
int numberOfSharpEdgesPerColumn_1s[PIX_PER_ROW];
int numberOfSharpEdgesPerColumn[PIX_PER_ROW];
int numberOfSharpEdges_Hist_1s[10];
int averageOfSharpEdges;
int averageOfHumanPixels;
int numberOfHumanPixels_hist[10];
int tempDiffHistVektor[3];
int	tempDiffAverageOver3s_hist_1s;

//int numberOfSharpEdges_hist[10];
//int averageOfHumanPixels;

//volatile locationStruct areasOfInterest_Hist_1s[32];

int edgeImage[NUMBER_OF_ROWS][PIX_PER_ROW];


signed short SP_MaxTemperature(void)
{
	uint16_t maxtemp;
	uint8_t i,j;
	
	maxtemp = 0;
	
	for(i = 0; i < NUMBER_OF_ROWS; i++)
	{
		for(j = 0; j < PIX_PER_ROW; j++)
		{
			if (SensorImage[i][j] > maxtemp)
				maxtemp = SensorImage[i][j];
		}
	}
	
	return maxtemp;
}
void saveTemperatureImage_1s(void)
{
	for(int i = 0;i<NUMBER_OF_ROWS;i++)
	{
		
		for(int j=0;j<PIX_PER_ROW;j++)
		{
			SensorImage_Hist_1s[i][j]=SensorImage[i][j];
		}
	}
}
char lookForAreasOfInterest()
{
		
	//short rowCount = 0;
	//short pixCount = 0;
	//short firstRow = 0;
	
	
	areaCount = 0;
	//rowCount = 0;
	for(int i = 0;i<ROW_FOR_PRESENCE_DETECTION;i++)
	{
		
		for(int j=0;j<PIX_PER_ROW;j++)
		{
				if(edgeImage[i][j] == 1)
				{
				
					areasOfInterest[areaCount] = checkArea(i,j);
					
					
					areasOfInterest[areaCount].averageTemperature= eraseArea(areasOfInterest[areaCount].xMin,areasOfInterest[areaCount].xMax, areasOfInterest[areaCount].yMin, areasOfInterest[areaCount].yMax);
					areaCount++;
				}
				else;
					//j = j+lengthOfArea;
					
		}
	}
	
	//Nolla resterarande AOI:s i vektorn
	
	for(int j = areaCount;j<32;j++)
	{
		areasOfInterest[j].inUse = false;
	}
	
	return areaCount;
}
char checkForTestHeatingZones(void)
{
	//char resultOfAOIAnalysis;
	char numberOfInterestingAreas; 
	locationStruct bigAOI[5];
	locationStruct result;
	int j = 0;
	//char presenceFlag;
	//char movementFlag;
	
	numberOfInterestingAreas  = 0;
	//averageFilteringOverTime(); 
	//averageFilter();
	
	//SOMEONE_PRESENT_FLAG = someonePresentVersion2(ROW_FOR_PRESENCE_DETECTION);
	//MOVEMENT_FLAG = someoneMoving(ROW_FOR_PRESENCE_DETECTION);
	
	
	
	result = lookForTheHotestArea(0,0);
	edgeFilter();
	
	//MOVEMENT_FLAG = someoneMoving(ROW_FOR_PRESENCE_DETECTION);
	//someonePresent(ROW_FOR_PRESENCE_DETECTION);

	if(result.hotestTemperature>TL_STOVE_ON)
	{
		//edgeFilter();
		numberOfInterestingAreas = lookForAreasOfInterest();
		
		for(int i=0;i<numberOfInterestingAreas;i++)
		{
			if(areasOfInterest[i].size > 20) //(TL_CUT_POWER-(DIP_Boiler*TL_BOILING_CUT_COMP)))
			{	
					bigAOI[j].xPos = areasOfInterest[i].xPos;
					bigAOI[j].yPos = areasOfInterest[i].yPos;
				
					j++;
					if(j>4)		//The array size is 5 so it cannot be bigger than 4. The size of the array of 5 is just taken. The user should only use two hotplates for testing so it shouldnt be more than two hotspots.
						j=4;
			}
		}
			
		if(j > 1)	//We have detected more than 1 hotspot that is big
		{
			
			if((abs(bigAOI[0].xPos-bigAOI[1].xPos) > 4) && (abs(bigAOI[0].yPos-bigAOI[1].yPos) > 4) )
					return TRUE;
			else
				return FALSE;
		}
		else
			return FALSE;
	}
	else
		return FALSE;
	
	
}
int eraseArea(short xMin, short xMax, short yMin, short yMax)
{
	int i = 0;
	int j = 0;
	int pixelCounter = 0;
	long temperatureSumOfAllPixels = 0;
	 
	//i = yMin;
	//j = xMin;
	
	for(i=yMin;i<=yMax;i++)
	{
		j=xMin;
 		for(j=xMin;j<=xMax;j++)
		{
				pixelCounter++;
				temperatureSumOfAllPixels+=SensorImage[i][j];
				edgeImage[i][j] = 0;
				if(SensorImage[i][j] > areasOfInterest[areaCount].hotestTemperature)
				{
					areasOfInterest[areaCount].hotestTemperature = SensorImage[i][j];
					areasOfInterest[areaCount].xPos = j;
					areasOfInterest[areaCount].yPos = i;
				}			
		}
	}
	
	return (temperatureSumOfAllPixels/pixelCounter);
	 
}

char movementDetection(int lookToRow)
{
	
	//int numberOfHumanPixels = 0;
	int numberOfSharpEdges;
	//int diffOfSharpEdges = 0;
	int tempDifference;
	int diffInAverage;
	int diffTemperatur;									//this variable will store the difference in the tempDiff compared to the average tempDiff
	int tempDiffResult;
	
	int tempDiffAverageOver3s;
	//bool tempDifferenceFlag;
	//bool numberOfSharpEdgesFlag;
	tempDiffAverageOver3s = 0;
	diffInAverage = 0;
	tempDifference = 0;
	diffTemperatur = 0;
	tempDiffResult = 0;
	
	//numberOfHumanPixels=0;
	numberOfSharpEdges = 0;
	
	for(int column = 0;column< PIX_PER_ROW;column++)
	{
		tempHistPerColumn_0s[column]=0;
		numberOfEdgesPerColumn[column] = 0;
		for(int row = ROW_FOR_PRESENCE_DETECTION;row<NUMBER_OF_ROWS;row++)
		{
				// +/-6 means a relative sharp edge in the picture
				if((edgeImage[row][column] < -6)||(edgeImage[row][column] > 6))													// -6 means a relative sharp edge in the picture
				{
					numberOfSharpEdges++;																																			//This will hold the total number of sharp edges in the "movement" zone of the sensor
					//numberOfHumanPixels++;
					numberOfSharpEdgesPerColumn[column]++;																										//This will hold number of sharp edges for this column
				}		
				if(edgeImage[row][column] != 0)																														//!=0 -> all edges, even the smaller ones
				{
					numberOfEdgesPerColumn[column]=numberOfEdgesPerColumn[column]+SensorImage[row][column];		//This will hold the number of edges, even smaller ones
				}
				
				
				if(SensorImage_Hist_1s[row][column]>=SensorImage[row][column])																				//Here we will check the difference in the temperature for the last second
				{
					tempDifference = tempDifference + (SensorImage_Hist_1s[row][column]-SensorImage[row][column]);			//we will save the total difference in the temperature
				}
				else
				{
					tempDifference = tempDifference + (SensorImage[row][column]-SensorImage_Hist_1s[row][column]);
				}
				
		}
	}
	averageOfSharpEdges=0;
	for(int j=9;j>0;j--)
	{
		numberOfSharpEdges_Hist_1s[j] = numberOfSharpEdges_Hist_1s[j-1];
		averageOfSharpEdges = averageOfSharpEdges + numberOfSharpEdges_Hist_1s[j];
	}
	numberOfSharpEdges_Hist_1s[0] = numberOfSharpEdges;
	averageOfSharpEdges = averageOfSharpEdges + numberOfSharpEdges;	
	averageOfSharpEdges = (int)averageOfSharpEdges / 10;
						//Use this in debug mode
	//printf("Skillnad i bild:  ");									//Use this in debug mode
	#ifdef DebugSensordata	
	printf(" %d",tempDifference);								//Use this in debug mode
	#endif
	//printf(" %d", numberOfSharpEdges);
	//printf(" %d", averageOfSharpEdges);

	for(int k=2;k>0;k--)
	{
		tempDiffHistVektor[k]=tempDiffHistVektor[k-1];
	}
	tempDiffHistVektor[0]=tempDifference;
	tempDiffAverageOver3s = (tempDiffHistVektor[0]+tempDiffHistVektor[1]+tempDiffHistVektor[2])/3;
	
	diffInAverage = tempDiffAverageOver3s - tempDiffAverageOver3s_hist_1s;
	tempDiffAverageOver3s_hist_1s=tempDiffAverageOver3s;
	

	
	diffTemperatur = abs(tempDiffAverageOver3s-tempDifference);								//this variable will store the difference in the tempDiff compared to the average tempDiff
	tempDiffResult = abs(diffTemperatur*diffInAverage) ;
	#ifdef DebugSensordata	
	printf(" %d", tempDiffResult);
	printf("\r\n");
	#endif
	if(tempDiffResult > AVERAGE_TEMPERATURE_DIFFERENCE_TRESHHOLD)
	{
			//We have had a movement. If smart timer active, reset time to zero.
			if(DIP_Smart_timer == TRUE)
				runtime_stove = 0;
		
						
 			//PMAIF_LED_Set(YELLOW,SOLID);
			//nrf_delay_ms(100);
			return true;
	
	}
	else		
		return false;

	
	/*diffOfSharpEdges = abs(numberOfSharpEdges - averageOfSharpEdges);
	printf(" %d", diffOfSharpEdges);
	printf("\r\n");

	
	if(diffOfSharpEdges>4)
	{
		//PMAIF_LED_Set(BLUE,SOLID);
		//nrf_delay_ms(1000);
		return true;
	}
	else
		return false;*/

}
	
/* 
char someonePresent(int lookToRow)
{
	
	int numberOfHumanPixels = 0;
	int diffOfHumanPixels = 0;
	
	numberOfHumanPixels=0;
	
	for(int column = 0;column< PIX_PER_ROW;column++)
	{
		tempHistPerColumn_0s[column]=0;
		for(int row = lookToRow;row<NUMBER_OF_ROWS;row++)
		{
				if((SensorImage[row][column] > BODY_TEMP_LOWER_LIMIT)&&(SensorImage[row][column] < BODY_TEMP_UPPER_LIMIT))
				{
					numberOfHumanPixels++;
					tempHistPerColumn_0s[column]++;
				}			
		}
	}
	averageOfHumanPixels=0;
	for(int j=9;j>0;j--)
	{
		numberOfHumanPixels_hist[j] = numberOfHumanPixels_hist[j-1];
		averageOfHumanPixels = averageOfHumanPixels + numberOfHumanPixels_hist[j];
	}
	numberOfHumanPixels_hist[0] = numberOfHumanPixels;
	averageOfHumanPixels = averageOfHumanPixels + numberOfHumanPixels;
	averageOfHumanPixels = (int)averageOfHumanPixels / 10;
	if(minimumOfHumanPixels > numberOfHumanPixels)				//Use this in debug mode
		minimumOfHumanPixels = numberOfHumanPixels;					//Use this in debug mode
	
	printf("%d  ",averageOfHumanPixels);									//Use this in debug mode
	printf("%d    ",numberOfHumanPixels);								//Use this in debug mode
	
	diffOfHumanPixels = abs(numberOfHumanPixels-averageOfHumanPixels);
 	if(diffOfHumanPixels>HUMAN_PIXELS_DELTA_TRESHHOLD)
	{
			//set_leds(0xff,0x00,0x00,0xff);
			//nrf_delay_ms(500);
			//set_leds(0x00,0x00,0x00,0xff);
			//nrf_gpio_pin_set(LED_1);
			//nrf_delay_ms(200);
			//nrf_gpio_pin_clear(LED_1);
			//nrf_delay_ms(1000);
			PMAIF_LED_Set(WHITE,SOLID);
			nrf_delay_ms(1000);
		return true;
	}
	else
		return false;
	
}
char someoneMoving(int lookToRow)
{
	//char resultFlag = false
	int edgeDiff;
	edgeDiff=0;
	for(int column = 0;column< PIX_PER_ROW;column++)
	{
			if(numberOfSharpEdgesPerColumn_1s[column] == 0)
			{
				if(numberOfSharpEdgesPerColumn[column] != 0)
					edgeDiff++;
			}
			else
			{
				if(numberOfSharpEdgesPerColumn[column] == 0)
					edgeDiff++;
			
					
				
			}	
	}	
	for(int column = 0;column< PIX_PER_ROW;column++)
	{
		numberOfSharpEdgesPerColumn_1s[column] = numberOfSharpEdgesPerColumn[column];
	}
	//printf(" %d", edgeDiff);
	//printf("\n");
	if(edgeDiff>1)
	{
 		PMAIF_LED_Set(YELLOW,SOLID);
		nrf_delay_ms(1000);
		return true;
	}
	else
	  return false;
	
}*/

void checkForNegativeDerivate(char numberOfAreasToAnalyze)
{
	for(int i=0;i<numberOfAreasToAnalyze;i++)
	{
		if(areasOfInterest[i].inUse == true) //(TL_CUT_POWER-(DIP_Boiler*TL_BOILING_CUT_COMP)))
		{
			for(int j=0;j<32;j++)				//Check all former AOI:s to see if they are in the same area
			{
				if(areasOfInterest_Hist_1s[j].inUse==true)
				{
					if((areasOfInterest[i].xMin >= areasOfInterest_Hist_1s[j].xMin)&&(areasOfInterest[i].xMax <= areasOfInterest_Hist_1s[j].xMax)&&(areasOfInterest[i].yMin >= areasOfInterest_Hist_1s[j].yMin)&&(areasOfInterest[i].yMax <= areasOfInterest_Hist_1s[j].xMax))
					{
						if(areasOfInterest[i].averageTemperature < areasOfInterest_Hist_1s[j].averageTemperature)
							areasOfInterest[i].negativeDerivate = true;
						else
							areasOfInterest[i].negativeDerivate = false;
					}
				}
			}
		}
	}
}
void saveHotestTemperaturInArray_10s(locationStruct hotestTemp)
{
		for(int k = 9;k>0;k--)
		{
				hotestTemperatureHistogram_10s[k] = hotestTemperatureHistogram_10s[k-1];
		}
		hotestTemperatureHistogram_10s[0] = hotestTemp;
		
}


char analyzeTemperature()
{
	char resultOfAOIAnalysis;
	char numberOfInterestingAreas; 
	locationStruct result;
	
	//char presenceFlag;
	//char movementFlag;
	
	numberOfInterestingAreas  = 0;
	//averageFilteringOverTime(); 
	//averageFilter();
	
	//SOMEONE_PRESENT_FLAG = someonePresentVersion2(ROW_FOR_PRESENCE_DETECTION);
	//MOVEMENT_FLAG = someoneMoving(ROW_FOR_PRESENCE_DETECTION);
	
	
	
	result = lookForTheHotestArea(0,0);
	hotestTemperature = result.hotestTemperature;
	if(whenToSaveHotestTemperatureCounter > 9)
	{
		saveHotestTemperaturInArray_10s(result);
		whenToSaveHotestTemperatureCounter = 0;
	}
	else 
		whenToSaveHotestTemperatureCounter++;
	edgeFilter();
	MOVEMENT_FLAG = movementDetection(ROW_FOR_PRESENCE_DETECTION);
	//MOVEMENT_FLAG = someoneMoving(ROW_FOR_PRESENCE_DETECTION);
	//someonePresent(ROW_FOR_PRESENCE_DETECTION);

	if(result.hotestTemperature>TL_STOVE_ON)
	{
		//edgeFilter();
		numberOfInterestingAreas = lookForAreasOfInterest();
		
		if(numberOfInterestingAreas > 0)
		{
			//OBS!!!Detta r en mycket enkel algoritm som bara tittar p varmaste punkten i en AOI. Hr mste vi bygga vidare s att man analyserar hela ytan.
				/*#ifndef BATTERY_DRIVEN		
				movementOnStoveFlag = checkForRapidTemperatureIncrease();
				#else
				if(hotestTemperature > TL_LARM_VISUAL)
					movementOnStoveFlag = checkForRapidTemperatureIncrease();
				else
					movementOnStoveFlag = false;
				#endif*/
				movementOnStoveFlag = checkForRapidTemperatureIncrease();
				checkForNegativeDerivate(numberOfInterestingAreas);
				resultOfAOIAnalysis = analyzeAOI(numberOfInterestingAreas);
				saveAreasOfInterest();
				return resultOfAOIAnalysis;
				
		}
		else
			return TF_STOVE_OFF;		//If we dont have any interesting areas means that we dont have any heat on.
		
	}
	else
	{
		eraseAreasOfInterest();
		return 0;
	}
	
	
}
void eraseAreasOfInterest()
{
	int i= 0;
	while((areasOfInterest[i].inUse != false)||(i<32))
	{
			areasOfInterest[i].inUse = false;
			i++;
	}
	
}
void saveAreasOfInterest()
{
	int i= 0;
	int k;
	
	//printf("\r\n -------------------AOI data--------------------\n");
	while((areasOfInterest[i].inUse == true)&&(i<32))
	{
			areasOfInterest_Hist_1s[i].inUse = areasOfInterest[i].inUse;
			areasOfInterest_Hist_1s[i].xMin = areasOfInterest[i].xMin;
			areasOfInterest_Hist_1s[i].xMax = areasOfInterest[i].xMax;
			areasOfInterest_Hist_1s[i].yMin = areasOfInterest[i].yMin;
			areasOfInterest_Hist_1s[i].yMax = areasOfInterest[i].yMax;
			areasOfInterest_Hist_1s[i].hotestTemperature = areasOfInterest[i].hotestTemperature;
			areasOfInterest_Hist_1s[i].size = areasOfInterest[i].size;
			areasOfInterest_Hist_1s[i].xPos = areasOfInterest[i].xPos;
			areasOfInterest_Hist_1s[i].yPos = areasOfInterest[i].yPos;
			areasOfInterest_Hist_1s[i].averageTemperature = areasOfInterest[i].averageTemperature;
			
	#ifdef DebugSensordata	
		printf("Hotest: %d  ",areasOfInterest_Hist_1s[i].hotestTemperature);
		printf("Size: %d  ",areasOfInterest_Hist_1s[i].size);
		printf("Avereage: %d  ",areasOfInterest_Hist_1s[i].averageTemperature);
		printf("Position: %d  %d",areasOfInterest_Hist_1s[i].xPos,areasOfInterest_Hist_1s[i].yPos);
			
			printf("\r\n -------------------------------------------------------\n");
		#endif
		i++;
		
	}
	//Nolla resterarande AOI:s i vektorn
	for(k=i;k<32;k++)
	{
		areasOfInterest_Hist_1s[k].inUse = false;
	}
}
/*char checkForRapidTemperatureIncrease_v2()
{
	
	int m = 0;
	int n = 0;
	int k = 0;
	//int o = 0;
	//int l = 0;
	int tempDiff;
	
	int numberOfPixelsWithHighPositveDerivate = 0;
	//int numberOfRapidTemperatureIncreasePixels = 0;
	//int temperatureDifference = 0;
	char result = false;
	tempDiff = 0;
	//printf("\r\n");	
	for(int i = 0;i<NUMBER_OF_ROWS;i++)
	{
		
		for(int j=0;j<PIX_PER_ROW;j++)
		{
			tempDiffImage_1s[i][j] = abs(SensorImage[i][j] - SensorImage_Hist_1s[i][j]);
			if(tempDiffImage_1s[i][j] > temperatureDerivateTreshhold)
					tempDiffImage_1s[i][j] = 1;
			else
				 tempDiffImage_1s[i][j] = 0;
			//printf("%d ",tempDiffImage_1s[i][j]);
		}
		//printf("\r\n");	
	}
	
	while((areasOfInterest_Hist_1s[k].inUse == true)&&(k<32))
	{
		numberOfPixelsWithHighPositveDerivate = 0;
		for(m=areasOfInterest_Hist_1s[k].yMin; m<=areasOfInterest_Hist_1s[k].yMax; m++)
		{
			
			for(n=areasOfInterest_Hist_1s[k].xMin;n<=areasOfInterest_Hist_1s[k].xMax;n++)
			{
				if(SensorImage[m][n]> SensorImage_Hist_1s[m][n])
				{
					tempDiff = SensorImage[m][n]-SensorImage_Hist_1s[m][n];
					if(tempDiff > temperatureDerivateTreshhold)
						numberOfPixelsWithHighPositveDerivate++;
				}
			}
	
		}
		if(numberOfPixelsWithHighPositveDerivate > numberOfPixelsWithHighPositveDerivateTreshhold)
		{
			areasOfInterest[k].highPositiveDerivate = 1;
			PMAIF_LED_Set(BLUE,SOLID);
			nrf_delay_ms(1000);
		}
		else
			areasOfInterest[k].highPositiveDerivate = 0;
		
		k++;
	}
	
	
	
	return result;
}*/
char checkForRapidTemperatureIncrease()
{
	
	int m = 0;
	int n = 0;
	int k = 0;
	int o = 0;
	int l = 0;
	int numberOfPixelsWithHighDerivate = 0;
	int numberOfPixelsWithHighDerivateInAOI = 0;
	//int numberOfRapidTemperatureIncreasePixels = 0;
	//int temperatureDifference = 0;
	//char result = false;
	//printf("\r\n");	
	for(int i = 0;i<ROW_FOR_PRESENCE_DETECTION;i++)
	{
		
		for(int j=0;j<PIX_PER_ROW;j++)
		{
			if(SensorImage[i][j] > SensorImage_Hist_1s[i][j])
			{
				tempDiffImage_1s[i][j] = SensorImage[i][j] - SensorImage_Hist_1s[i][j]; //abs(SensorImage[i][j] - SensorImage_Hist_1s[i][j]);
				#ifdef BATTERY_DRIVEN
				if(tempDiffImage_1s[i][j] > TEMPERATURE_DERIVATE_TRESHHOLD_BATTERY)
				{
						tempDiffImage_1s[i][j] = 1;
						numberOfPixelsWithHighDerivate++;
				}
				else
					 tempDiffImage_1s[i][j] = 0;
				#else
				if(tempDiffImage_1s[i][j] > TEMPERATURE_DERIVATE_TRESHHOLD)
				{
						tempDiffImage_1s[i][j] = 1;
						numberOfPixelsWithHighDerivate++;
				}
				else
					 tempDiffImage_1s[i][j] = 0;
				#endif
			}
			//printf("%d ",tempDiffImage_1s[i][j]);
		}
		//printf("\r\n");	
	}
	numberOfPixelsWithHighDerivateInAOI =0;
	while((areasOfInterest[k].inUse == true)&&(k<32))
	{
		//take out the minimum borders to look in
		n = areasOfInterest[k].xMin;
		if((n-AREA_SIZE_TOLERANCE)>=0)
				n=n-AREA_SIZE_TOLERANCE;
		else
			n = 0;
		
		m = areasOfInterest[k].yMin;
		if((m-AREA_SIZE_TOLERANCE)>=0)
			m=m-AREA_SIZE_TOLERANCE;
		else
			m = 0;
		
		//take out the maximum borders to look in.
		o = areasOfInterest[k].xMax;
		if((o+AREA_SIZE_TOLERANCE) < PIX_PER_ROW)
			o = o + AREA_SIZE_TOLERANCE;
		else
			o = PIX_PER_ROW;
		
		l = areasOfInterest[k].yMax;
		if ((l+AREA_SIZE_TOLERANCE) < ROW_FOR_PRESENCE_DETECTION)
			l = l + AREA_SIZE_TOLERANCE;
		else
			l = ROW_FOR_PRESENCE_DETECTION;
		
		
		for( m; m <= l; m++)
		{
			
			for(n;n<=o;n++)
			{
				if(tempDiffImage_1s[m][n] == 1)
					numberOfPixelsWithHighDerivateInAOI++;
			}
	
		}
		if(numberOfPixelsWithHighDerivateInAOI > NUMBER_OF_PIXELS_WITH_HIGH_DERIVATE_IN_AOI_TRESHHOLD)
		{
			areasOfInterest[k].highPositiveDerivate = 1;
			//PMAIF_LED_Set(BLUE,FAST_BLINK);
			//nrf_delay_ms(1000);
		}
		else
			areasOfInterest[k].highPositiveDerivate = 0;
		
		k++;
	}
	#ifdef MOVEMENT
	printf("Antal pixlar med positiv derivata: %d", numberOfPixelsWithHighDerivateInAOI);
	printf("\r\n");
	printf("debugWatch: %d", numberOfPixelsWithHighDerivate);
	printf("\r\n");
	#endif
	if(numberOfPixelsWithHighDerivate > NUMBER_OF_PIXELS_WITH_HIGH_DERIVATE_TRESHHOLD)
	{	
			areasOfInterest[k].highPositiveDerivate = 1;
			//PMAIF_LED_Set(BLUE,FAST_BLINK);
			//nrf_delay_ms(1000);
			return TRUE;
	}
	else
		return FALSE;

}
char analyzeAOI(char numberOfAreasToAnalyze)
{
	char result = 0;
	int i = 0;
	
	//Update larmlevels in case of change in DIP settings (boiling function)
	//IF magnet is place the heatguard should work like standard even when it comes to Warning levels
	if(!MAGNETSTATUS)
	{
		warningLevelVisual = TL_LARM_VISUAL-(DIP_Boiler*TL_BOILING_VISUAL_LARM_COMP);
		warningLevelSound = TL_LARM_SOUND-(DIP_Boiler*TL_BOILING_SOUND_LARM_COMP);
		cutPowerLevel = TL_CUT_POWER-(DIP_Boiler*TL_BOILING_CUT_COMP);
	}
	else
	{
		warningLevelVisual = TL_LARM_VISUAL;
		warningLevelSound = TL_LARM_SOUND;
		cutPowerLevel = TL_CUT_POWER;
	}
	for(i=0;i<numberOfAreasToAnalyze;i++)
	{
		if(areasOfInterest[i].hotestTemperature > cutPowerLevel) //(TL_CUT_POWER-(DIP_Boiler*TL_BOILING_CUT_COMP)))
		{
			if(areasOfInterest[i].highPositiveDerivate == true)
					result = TF_FIRST_LARM_LEVEL;
			else
				result = TF_CUT_POWER ;
		}	
		else if(areasOfInterest[i].hotestTemperature > warningLevelSound) //(TL_LARM_SOUND-(DIP_Boiler*TL_BOILING_SOUND_LARM_COMP)))
		{
			if(areasOfInterest[i].highPositiveDerivate == true)
					result = TF_FIRST_LARM_LEVEL;
			else
				result = TF_SECOND_LARM_LEVEL;
		}	
		else if(areasOfInterest[i].hotestTemperature > warningLevelVisual)  //(TL_LARM_VISUAL-(DIP_Boiler*TL_BOILING_VISUAL_LARM_COMP)))
		{
			if(result < TF_FIRST_LARM_LEVEL)
				result = TF_FIRST_LARM_LEVEL;
		}	
		/*else if(areasOfInterest[i].hotestTemperature > TL_OVER_BOILING)
		{
			if(result < TF_OVER_BOILING)
				result = TF_OVER_BOILING;
		}	*/
		else if(areasOfInterest[i].hotestTemperature > TL_STOVE_ON)
		{
			if(result < TF_STOVE_ON)
				result = TF_STOVE_ON;
		}	
		else if(areasOfInterest[i].hotestTemperature <= TL_STOVE_ON)
		{
			if(result < TF_STOVE_ON)
				result = TF_STOVE_OFF;
		}
		else 
			 result = TF_STOVE_OFF;
	}
	
	return result;
}


locationStruct lookForTheHotestArea(int i, int j)
{
	short maxTemperature = 0;
	locationStruct positionOfHotestArea;


	for(int i = 0;i<NUMBER_OF_ROWS;i++)
	{
		for(int j=0;j<PIX_PER_ROW;j++)
		{
			if(SensorImage[i][j]>maxTemperature)
			{
					maxTemperature = SensorImage[i][j];
					positionOfHotestArea.xMin=j;
					positionOfHotestArea.yMin=i;
					
			}
		
		}
	}
	positionOfHotestArea.hotestTemperature=maxTemperature;
	return positionOfHotestArea;
}
locationStruct checkArea(int i, int j)
{

	short xMax = j;
	short yMax = i;
	short yMin = i;
	short xMin = j;
	short maskState;
	//bool runFlag = true;
	int widthOfArea = 0;
	int heightOfArea = 0;
	locationStruct result;
	
	runFlag = true;
	
	maskState = CHECK_RIGHT;
	while(runFlag)
	{	
			switch(maskState)
			{
				case CHECK_RIGHT:
					if(checkUpRight(i,j))
					{
						maskState = CHECK_UP_RIGHT;
						j++;
						i--;
			
					}
			
					else if(checkRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						if(j>xMax)
							xMax=j;
					}
					else if (checkDownRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						i++;
						if(j>xMax)
							xMax=j;					
						if(i>yMax)
							yMax=i;
					}
					else if(checkDown(i,j))
					{
						maskState = CHECK_DOWN;
						i++;
						if(i>yMax)
							yMax=i;
					}
					else if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
		
					else
						runFlag = false;
						
					break;
			case CHECK_DOWN_RIGHT:
					if(checkRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						if(j>xMax)
							xMax=j;
						if(i>yMax)
							yMax=i;
					}
					else if (checkDownRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						i++;
						if(j>xMax)
							xMax=j;					
						if(i>yMax)
							yMax=i;
					}
					else if(checkDown(i,j))
					{
						maskState = CHECK_DOWN;
						i++;
						if(i>yMax)
							yMax=i;
					}
					else if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else
						runFlag = false;
						
					break;
						

				case CHECK_DOWN:
				
					if(checkDownRight(i,j))
					{
						maskState = CHECK_DOWN_RIGHT;
						i++;
						j++;
						if(j>xMax)
							xMax = j;
						if(i>yMax)
							yMax=i;
					}
					else if(checkDown(i,j))
					{
						maskState = CHECK_DOWN;
						i++;

						if(i>yMax)
							yMax = i;
					}
					else if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;//i++;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
				
					else
						runFlag = false;
						
					break;
					
				case CHECK_DOWN_LEFT:
				
					if(checkDownRight(i,j))
					{
						maskState = CHECK_DOWN_RIGHT;
						i++;
						j++;
						if(j>xMax)
							xMax = j;
						if(i>yMax)
							yMax=i;
					}
					else if(checkDown(i,j))
					{
						maskState = CHECK_DOWN;
						i++;

						if(i>yMax)
							yMax=i;
					}
					else if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
				
					else
						runFlag = false;
						
					break;
					
			case CHECK_LEFT:
				
				
					if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
					else if(checkUp(i,j))
					{
						maskState = CHECK_UP;
						
						i--;
			
					}
					else
						runFlag = false;
						
					break;
				
			case CHECK_UP_LEFT:
				
				
					if(checkDownLeft(i,j))
					{
						maskState = CHECK_DOWN_LEFT;
						j--;
						i++;
						if(j<=xMin)
							xMin = j;
						if(i>yMax)
							yMax = i;
					}
					else if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
					else if(checkUp(i,j))
					{
						maskState = CHECK_UP;
						
						i--;
			
					}
					else if(checkUpRight(i,j))
					{
						maskState = CHECK_UP;
						j++;
						i--;
			
					}
					else
						runFlag = false;
						
					break;
					
					
			case CHECK_UP:
				
					if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
					else if(checkUp(i,j))
					{
						maskState = CHECK_UP;
						
						i--;
			
					}
					else if(checkUpRight(i,j))
					{
						maskState = CHECK_UP_RIGHT;
						j++;
						i--;
			
					}
					else if(checkRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						
			
					}
					else
						runFlag = false;
						
					break;
					
			case CHECK_UP_RIGHT:
				
					if(checkLeft(i,j))
					{
						maskState = CHECK_LEFT;
						j--;
						if(j<=xMin)
							xMin = j;
					}
					else if(checkUpLeft(i,j))
					{
						maskState = CHECK_UP_LEFT;
						j--;
						i--;
						if(j < xMin)
							xMin = j;
					}
					else if(checkUp(i,j))
					{
						maskState = CHECK_UP;
						
						i--;
			
					}
					else if(checkUpRight(i,j))
					{
						maskState = CHECK_UP_RIGHT;
						j++;
						i--;
			
					}
					else if(checkRight(i,j))
					{
						maskState = CHECK_RIGHT;
						j++;
						if(j > xMax)
							xMax = j;
						
			
					}
					else
						runFlag = false;
						
					break;				
					
					
				
	}
	

	
	}
	result.xMax=xMax;
	result.xMin=xMin;
	result.yMax=yMax;
	result.yMin=yMin;
	result.highPositiveDerivate = 0;
	result.inUse = true;
	widthOfArea = xMax - xMin;
	if(widthOfArea==0)
		widthOfArea=1;
	heightOfArea = yMax - yMin;
	if(heightOfArea==0)
		heightOfArea=1;
	result.hotestTemperature = 0;
	result.size = widthOfArea*heightOfArea;
	
	result.size = widthOfArea * heightOfArea;
	
	return result;
	
}

char checkRight(int i, int j)
{
	if(j< (PIX_PER_ROW-1))
	{
		if(edgeImage[i][j+1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i][j+1]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkDownRight(int i, int j)
{
	if((j<(PIX_PER_ROW-1))&&(i<(ROW_FOR_PRESENCE_DETECTION)))
	{
		if(edgeImage[i+1][j+1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i+1][j+1]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkDown(int i, int j)
{
	if(i < (ROW_FOR_PRESENCE_DETECTION))
	{
		if(edgeImage[i+1][j]==1)
		{
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i+1][j]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkDownLeft(int i, int j)
{
	if(j>0&&(i<(ROW_FOR_PRESENCE_DETECTION)))
	{
		if(edgeImage[i+1][j-1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i+1][j-1]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;	
}
char checkLeft(int i, int j)
{	
	if(j>0)
	{
		if(edgeImage[i][j-1]==1)
		{
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i][j-1]==BT_VALUE)
		{
				runFlag = false;
				return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkUpLeft(int i, int j)
{
	if((j>0)&&(i>0))
	{
		if(edgeImage[i-1][j-1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i-1][j-1]==BT_VALUE)
		{
			runFlag = false;
			return true;
		}
		else
			return false;
	}
	else
		return false;
}
char checkUp(int i, int j)
{
	if(i>0)
	{
		if(edgeImage[i-1][j]==1)
		{
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i-1][j]==BT_VALUE)
		{
				runFlag = false;
				return true;
		}
		else
			return false;
	}
	else
			return false;
}
char checkUpRight(int i, int j)
{
	if((j<(PIX_PER_ROW-1))&&(i>0))
	{
		if(edgeImage[i-1][j+1]==1)
		{	
			edgeImage[i][j] = BT_VALUE;
			return true;
		}
		else if(edgeImage[i-1][j+1]==BT_VALUE)
		{
				runFlag = false;
				return true;
		}
		else
			return false;
	}
	else
		return false;
}
void edgeFilter()
{
	short rowOffset;
	short colOffset;
	short sobel[3][3];
	//int tempResult;
	/*sobel[0][0]=1;
	sobel[0][1]=2;
	sobel[0][2]=1;
	sobel[1][0]=0;
	sobel[1][1]=0;
	sobel[1][2]=0;
	sobel[2][0]=-1;
	sobel[2][1]=-2;
	sobel[2][2]=-1;
	*/
	
	sobel[0][0]=1;
	sobel[0][1]=0;
	sobel[0][2]=-1;
	sobel[1][0]=2;
	sobel[1][1]=0;
	sobel[1][2]=-2;
	sobel[2][0]=1;
	sobel[2][1]=0;
	sobel[2][2]=-1;			//P detta filter som jag har testat mycket.

	
	int j, i;
	
		for(i = 0;i<NUMBER_OF_ROWS;i++)
	{
		for(j=0;j<PIX_PER_ROW-3;j++)
		{
			SensorImage[i][j] = (SensorImage[i][j]+SensorImage[i][j+1]+SensorImage[i][j+2])/3;
		}
	}
	
	for(i = ROW_FOR_PRESENCE_DETECTION;i<NUMBER_OF_ROWS;i++)
	{
		for(j=0;j<PIX_PER_ROW-3;j++)
		{
			SensorImage[i][j] = (SensorImage[i][j]+SensorImage[i][j+1]+SensorImage[i][j+2])/3;
		}
	}
	
	/*for(i = ROW_FOR_PRESENCE_DETECTION;i<(NUMBER_OF_ROWS-2);i++)
	{
		for(j=0;j<PIX_PER_ROW;j++)
		{
			SensorImage[i][j] = (SensorImage[i-1][j]+SensorImage[i][j]+SensorImage[i+2][j])/3;
		}
	}*/
	
	
	for(i = ROW_FOR_PRESENCE_DETECTION;i<NUMBER_OF_ROWS-1;i++)
	{
		for(j=1;j<PIX_PER_ROW-1;j++)
		{
			edgeImage[i][j]=0;
			for (rowOffset=-1; rowOffset<=1; rowOffset++) 
			{
							
				for (colOffset=-1; colOffset<=1; colOffset++) 
				{
					edgeImage[i][j] += sobel[1 + rowOffset][1 + colOffset]*SensorImage[i+rowOffset][j+colOffset];
					
				}
			}
			/*tempResult = edgeImage[i][j];
			if(tempResult > 5)
				edgeImage[i][j] = 1;
			else
				edgeImage[i][j] = 0.0;*/
		}
	}
	
	/*	for(i = ROW_FOR_PRESENCE_DETECTION;i<NUMBER_OF_ROWS;i++)
	{
		for(j=0;j<PIX_PER_ROW;j++)
		{
					SensorImage[i][j] = edgeImage[i][j];
			
			
		}
	}*/
	
	
	/*
	for(i = 0;i<NUMBER_OF_ROWS;i++)
	{
		for(j=0;j<PIX_PER_ROW-3;j++)
		{
			SensorImage[i][j] = (SensorImage[i][j]+SensorImage[i][j+1]+SensorImage[i][j+2])/3;
		}
	}*/
	
	
	for(int i = 0;i<ROW_FOR_PRESENCE_DETECTION;i++)
	{
		for(int j=0;j<PIX_PER_ROW;j++)
		{
			if(SensorImage[i][j] > TL_STOVE_ON)
				edgeImage[i][j]=1;
			else
				edgeImage[i][j]=0;
		}
	}
	
	//sendEdgeImage();

	
}
//------------------------------------ Prefi 2.3 nedan! ----------------------------------------

//// Kontrollera aktuellt kompenserat sensorvrde mot grnsen fr OVERHEAT
//// Om magnetnyckeln sitter p plats anses det vara en mer kompetent brukare av
//// spisen och en ngot hgre temperatur kan tilltas
//// Denna funktion kan utkas med en smartare grnshantering.

//unsigned char overheat(void)
//{
//	unsigned char returnvalue;
//	

//	if (MAGNET_STATUS)											// Det sitter en magnetnyckel p plats
//	{															// => tillt hgre temperatur!

//		LiU_Z1 = TEMPERATURE_WARNING_MAGNET + comp_sim_Z1 + comp_amb_Z1;
//		LiU_Z2 = TEMPERATURE_WARNING_MAGNET + comp_sim_Z2 + comp_amb_Z2;
//															
//		if (s1_average_10s > LiU_Z1)
//			returnvalue = TRUE;
//		else if(s2_average_10s > LiU_Z2)
//			returnvalue = TRUE;
//		else
//			returnvalue = FALSE;
//	}
//	else														// Ingen magnetnyckel. Normal tempgrns
//	{

//		if (SIMMERING_Z1_active == TRUE)
//			LiU_Z1 = (unsigned int) ( ((signed int) TEMPERATURE_WARNING_NORMAL) + comp_amb_Z1 + comp_sim_Z1);
//		else
//			LiU_Z1 = (unsigned int) ( ((signed int) TEMPERATURE_WARNING_NORMAL) + comp_amb_Z1);

//		if (SIMMERING_Z2_active == TRUE)
//			LiU_Z2 = (unsigned int) ( ((signed int) TEMPERATURE_WARNING_NORMAL) + comp_amb_Z2 + comp_sim_Z2);
//		else
//			LiU_Z2 = (unsigned int) ( ((signed int) TEMPERATURE_WARNING_NORMAL) + comp_amb_Z2);


//		if (s1_average_10s > LiU_Z1)
//			returnvalue = TRUE;
//		else if (s2_average_10s > LiU_Z2)
//			returnvalue = TRUE;
//		else
//			returnvalue = FALSE;
//	}

//	// Dessa temperaturgrnser kan overridas av SenseStateMachine! ->

//	switch(TEMPERATURE_STATUS)
//	{
//		case TEMP_LOW_FAST_RISING:

//			returnvalue = FALSE;

//		break;

//		default:

//		break;

//	}

//	return returnvalue;

//}

//----------------------------------------------------------------------------

// Kontrollera aktuellt kompenserat sensorvrde mot larmgrns fr FIRE
// Denna funktion kan utkas med en smartare grnshantering.

//unsigned char fire(void)
//{
//	if (TEMPERATURE_STATUS == TEMP_HIGHALARM)						// Temperaturgrnsen fr "brand" r oberoende av
//		return TRUE;											// magnetnyckel
//	else
//		return FALSE;
//}



// Prefi 2.3 compensation


////----------------------------------------------------------------------------

//void calc_compensation(void)
//{
//	static unsigned int sum;

//	static unsigned float factor;

//// Berkna omgivningstemperaturen

//	if (mainstate == STOVE_OFF)			// Bara uppdatera den ifall spisen r avstngd
//	{
//		if (load_sense_timer > 65000)	// ... och den har varit det i tminstone nstan tv timmar 
//		{

//			timer_owen_running = TRUE;

//			if (runtime_owen > 36000)		// Det har gtt en timma sen frra mtvrdet, ta ett nytt!
//			{

//				TAmb_Z1_hist_5 = TAmb_Z1_hist_4;
//				TAmb_Z1_hist_4 = TAmb_Z1_hist_3;
//				TAmb_Z1_hist_3 = TAmb_Z1_hist_2;
//				TAmb_Z1_hist_2 = TAmb_Z1_hist_1;
//				TAmb_Z1_hist_1 = s1_average_10s;
//	
//				sum = TAmb_Z1_hist_1;
//				sum += TAmb_Z1_hist_2;
//				sum += TAmb_Z1_hist_3;
//				sum += TAmb_Z1_hist_4;
//				sum += TAmb_Z1_hist_5;
//			
//				TAmb_Z1 = (unsigned int) (sum / (float) 5);

//				TAmb_Z2_hist_5 = TAmb_Z2_hist_4;
//				TAmb_Z2_hist_4 = TAmb_Z2_hist_3;
//				TAmb_Z2_hist_3 = TAmb_Z2_hist_2;
//				TAmb_Z2_hist_2 = TAmb_Z2_hist_1;
//				TAmb_Z2_hist_1 = s2_average_10s;

//				sum = TAmb_Z2_hist_1;
//				sum += TAmb_Z2_hist_2;
//				sum += TAmb_Z2_hist_3;
//				sum += TAmb_Z2_hist_4;
//				sum += TAmb_Z2_hist_5;
//			
//				TAmb_Z2 = (unsigned int) (sum / (float) 5);

//				runtime_owen = 0;			// Starta om fr en ny timmas vntan
//				
//			}

//		}
//		else
//		{
//			timer_owen_running = FALSE;
//			runtime_owen = 0;
//		}
//	}
//	else
//	{
//		timer_owen_running = FALSE;
//		runtime_owen = 0;
//	}


////------------------------
//// Simmeringkompenseringen r 0 vid TAmbient och def_SIMMERING_COMP_Z1 vid TEMPERATURE_WARNING_NORMAL

//// Justera simmeringniverna mot omgivningstemperatur???

//	factor = (float) ((float)(def_SIMMERING_MAX_COMP - def_SIMMERING_MIN_COMP) / (float) (def_SIMMERING_HIGH_LIMIT - def_SIMMERING_LOW_LIMIT));

//	if (s1_average_1s > def_SIMMERING_LOW_LIMIT)
//	{

//		if (s1_average_1s < def_SIMMERING_HIGH_LIMIT)
//		{
//			comp_sim_Z1 = def_SIMMERING_MIN_COMP + factor * ((float) (s1_average_1s - def_SIMMERING_LOW_LIMIT));
//		}
//		else
//			comp_sim_Z1 = def_SIMMERING_MAX_COMP;
//	}
//	else
//		comp_sim_Z1 = def_SIMMERING_MIN_COMP;


//	if (s2_average_1s > def_SIMMERING_LOW_LIMIT)
//	{

//		if (s2_average_1s < def_SIMMERING_HIGH_LIMIT)
//		{
//			comp_sim_Z2 = def_SIMMERING_MIN_COMP + factor * ((float) (s2_average_1s - def_SIMMERING_LOW_LIMIT));
//		}
//		else
//			comp_sim_Z2 = def_SIMMERING_MAX_COMP;
//	}
//	else
//		comp_sim_Z2 = def_SIMMERING_MIN_COMP;



////------------------------
//// Omgivningskompenseringen r 0 vid TAmbient och def_SIMMERING_COMP_Z1 vid TEMPERATURE_WARNING_NORMAL

//	factor = (float) ((float)(def_AMBIENT_MAX_COMP - def_AMBIENT_MIN_COMP) / (float) (def_AMBIENT_HIGH_LIMIT - def_AMBIENT_LOW_LIMIT));

//	if (TAmb_Z1 > def_AMBIENT_LOW_LIMIT)
//	{

//		if (TAmb_Z1 < def_AMBIENT_HIGH_LIMIT)
//		{
//			comp_amb_Z1 = def_AMBIENT_MIN_COMP + factor * ((float) (TAmb_Z1 - def_AMBIENT_LOW_LIMIT));
//		}
//		else
//			comp_amb_Z1 = def_AMBIENT_MAX_COMP;
//	}
//	else
//		comp_amb_Z1 = def_AMBIENT_MIN_COMP;

//	if (TAmb_Z2 > def_AMBIENT_LOW_LIMIT)
//	{

//		if (TAmb_Z2 < def_AMBIENT_HIGH_LIMIT)
//		{
//			comp_amb_Z2 = def_AMBIENT_MIN_COMP + factor * ((float) (TAmb_Z2 - def_AMBIENT_LOW_LIMIT));
//		}
//		else
//			comp_amb_Z2 = def_AMBIENT_MAX_COMP;
//	}
//	else
//		comp_amb_Z2 = def_AMBIENT_MIN_COMP;
//}


////----------------------------------------------------------------------------
