#include "globals.h"
/*
typedef struct
{
	char inUse;
	short xMin;
	short xMax;
	short yMin;
	short yMax;
	short hotestTemperature;
	short xPos;
	short yPos;
	int averageTemperature;
	int size;
	short highPositiveDerivate;
} locationStruct;
*/
char analyzeAOI(char numberOfAreasToAnalyze);
char lookForAreasOfInterest(void);
void edgeFilter(void);
void averageFilter(void);
locationStruct checkArea(int row, int col);
locationStruct lookForTheHotestArea(int i, int j);
char checkRight(int i, int j);
char checkDown(int i, int j);
char checkLeft(int i, int j);
char checkUp(int i, int j);
char checkUpRight(int i, int j);
char checkUpLeft(int i, int j);
char checkDownRight(int i, int j);
char checkDownLeft(int i, int j);
void averageFilteringOverTime(void);
void saveTemperatureImage_1s(void);
int eraseArea(short xMin, short xMax, short yMin, short yMax);
char analyzeTemperature(void);
void eraseAreasOfInterest(void);
void saveAreasOfInterest(void);
char checkForRapidTemperatureIncrease(void);
char checkForRapidTemperatureIncrease_v2(void);
//void sendInterestingAOI(char numberOfAOI);
char someonePresent(int lookToRow);
char someonePresentVersion2(int lookToRow);
char someoneMoving(int lookToRow);

#define CHECK_RIGHT 0
#define CHECK_DOWN 1
#define CHECK_LEFT 2
#define CHECK_UP 3
#define CHECK_UP_LEFT 4
#define CHECK_DOWN_LEFT 5
#define CHECK_DOWN_RIGHT 6
#define CHECK_UP_RIGHT 7

#define THRESHOLD 45
#define PROCESSED_PIX_VALUE 25
#define BT_VALUE 20

#define BODY_TEMP_UPPER_LIMIT 32
#define BODY_TEMP_LOWER_LIMIT 28 
//#define NUMBER_OF_BODY_TEMP_PIXELS_LIMIT 45
#define HUMAN_PIXELS_DELTA_TRESHHOLD 30
#define MOVEMENT_TRESHHOLD 15
#define IMAGE_COLLERATION_LIMIT 1024

#define TL_CUT_POWER 160  //300
#define TL_LARM_SOUND 150	//270
#define TL_LARM_VISUAL 130	//200				//Temperatur som skall resultera i varningssignal
#define TL_OVER_BOILING 80 //110
#define TL_STOVE_ON 45
 


signed short SP_MaxTemperature(void);
